import { h } from 'preact';
import { Consumer } from './Consumer';
/** @jsx h */

export function connect(map, actions, options) {
  if (options === void 0) {
    options = {};
  }

  return function connectComponent(Component) {
    var render = function render(mappedProps) {
      return h(Component, mappedProps);
    };

    var Connected = function Connected(props) {
      return h(Consumer, {
        map: map,
        actions: actions,
        pure: options.pure,
        sync: options.sync,
        observe: options.observe,
        originalProps: props,
        render: render
      });
    };

    return Connected;
  };
}