"use strict";

exports.__esModule = true;
exports.createConnect = createConnect;
exports.connect = void 0;

var _react = _interopRequireDefault(require("react"));

var _Consumer = require("./Consumer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createConnect(Consumer) {
  return function connect(map, actions, options) {
    if (options === void 0) {
      options = {};
    }

    return function connectComponent(Component) {
      var render = function render(mappedProps) {
        return _react.default.createElement(Component, mappedProps);
      };

      var Connected = function Connected(props) {
        return _react.default.createElement(Consumer, {
          displayName: Component.displayName || Component.name,
          map: map,
          actions: actions,
          pure: options.pure,
          sync: options.sync,
          observe: options.observe,
          debug: options.debug,
          originalProps: props,
          render: render
        });
      };

      return Connected;
    };
  };
}

var connect = createConnect(_Consumer.Consumer);
exports.connect = connect;