import React from 'react';
import { Consumer } from './Consumer';
export function createConnect(Consumer) {
  return function connect(map, actions, options) {
    if (options === void 0) {
      options = {};
    }

    return function connectComponent(Component) {
      var render = function render(mappedProps) {
        return React.createElement(Component, mappedProps);
      };

      var Connected = function Connected(props) {
        return React.createElement(Consumer, {
          displayName: Component.displayName || Component.name,
          map: map,
          actions: actions,
          pure: options.pure,
          sync: options.sync,
          observe: options.observe,
          debug: options.debug,
          originalProps: props,
          render: render
        });
      };

      return Connected;
    };
  };
}
export var connect = createConnect(Consumer);